for i, perk in ipairs(perk_list) do
	if perk.id == "ATTACK_FOOT" then
		if perk.func ~= nil then
			perk.func = function( entity_perk_item, entity_who_picked, item_name, pickup_count )
				local x,y = EntityGetTransform( entity_who_picked )
				local child_id = 0
				local is_stacking = GameHasFlagRun( "ATTACK_FOOT_CLIMBER" )
				
				print("DEBUG: Perk Picked Up" )

				local limb_count = 4
				if is_stacking then limb_count = 2 end
				for i=1,limb_count do
					child_id = EntityLoad( "data/entities/misc/perks/attack_foot/limb_walker.xml", x, y )
					
					sprite_components = EntityGetComponent(child_id, "SpriteComponent")
					for i, component in ipairs(sprite_components) do
						image = ComponentGetValue(component, "image_file")
						if image ~= nil then
							if string.find(image, "limb_a.png") then
								ComponentSetValue(component, "image_file", GlobalsGetValue("lukki_leg_sprite_file"))
							elseif string.find(image, "limb_B.png") then
								ComponentSetValue(component, "image_file", GlobalsGetValue("lukki_foot_sprite_file"))
							elseif string.find(image, "knee.png") then
								ComponentSetValue(component, "image_file", GlobalsGetValue("lukki_knee_sprite_file"))
							end
						end
					end
					
					EntityAddTag( child_id, "perk_entity" )
					EntityAddChild( entity_who_picked, child_id )
				end
				
				child_id = EntityLoad( "data/entities/misc/perks/attack_foot/limb_attacker.xml", x, y )
				
				sprite_components = EntityGetComponent(child_id, "SpriteComponent")
				for i, component in ipairs(sprite_components) do
					image = ComponentGetValue(component, "image_file")
					if image ~= nil then
						if string.find(image, "limb_a.png") then
							ComponentSetValue(component, "image_file", GlobalsGetValue("lukki_leg_sprite_file"))
						elseif string.find(image, "limb_B.png") then
							ComponentSetValue(component, "image_file", GlobalsGetValue("lukki_foot_sprite_file"))
						elseif string.find(image, "knee.png") then
							ComponentSetValue(component, "image_file", GlobalsGetValue("lukki_knee_sprite_file"))
						end
					end
				end
				
				EntityAddTag( child_id, "perk_entity" )
				EntityAddChild( entity_who_picked, child_id )
				
				if not is_stacking then
					-- enable climbing
					child_id = EntityLoad( "data/entities/misc/perks/attack_foot/limb_climb.xml", x, y )
					EntityAddTag( child_id, "perk_entity" )
					EntityAddChild( entity_who_picked, child_id )
					GameAddFlagRun( "ATTACK_FOOT_CLIMBER" )
				else
					-- add length to limbs
					for _,v in ipairs(EntityGetAllChildren(entity_who_picked)) do
						if EntityHasTag(v, "attack_foot_walker") then
							component_readwrite(EntityGetFirstComponent(v, "IKLimbComponent"), { length = 50 }, function(comp)
								comp.length = comp.length * 1.5
							end)
						end
					end
				end
				
				local platformingcomponents = EntityGetComponent( entity_who_picked, "CharacterPlatformingComponent" )
				if( platformingcomponents ~= nil ) then
					for i,component in ipairs(platformingcomponents) do
						local run_speed = tonumber( ComponentGetMetaCustom( component, "run_velocity" ) ) * 1.25
						local vel_x = math.abs( tonumber( ComponentGetMetaCustom( component, "velocity_max_x" ) ) ) * 1.25
						
						local vel_x_min = 0 - vel_x
						local vel_x_max = vel_x
						
						ComponentSetMetaCustom( component, "run_velocity", run_speed )
						ComponentSetMetaCustom( component, "velocity_min_x", vel_x_min )
						ComponentSetMetaCustom( component, "velocity_max_x", vel_x_max )
					end
				end
				
				perk_pickup_event("LUKKI")
				
				if ( pickup_count <= 2 ) then
					add_lukkiness_level(entity_who_picked)
				end
			end
		end
	end
end