dofile( "data/scripts/perks/perk.lua" )
dofile( "mods/prismatic_wardrobe/files/loadouts.lua" )

function OnPlayerSpawned( player_entity ) -- this runs when player entity has been created
	local init_check_flag = "start_loadouts_init_done"
	if GameHasFlagRun( init_check_flag ) then
		return
	end
	GameAddFlagRun( init_check_flag )

	-- ---
	local x, y = EntityGetTransform( player_entity )
	SetRandomSeed( x + 344, y - 523 )
	
	local loadout_rnd = Random( 1, #loadout_list )
	local loadout_choice = loadout_list[loadout_rnd]
	
	local cape = nil
	local player_arm = nil
	
	local loadout_cape_color = loadout_choice.cape_color
	local loadout_cape_color_edge = loadout_choice.cape_color_edge

	-- find the player cape and arm
	local player_child_entities = EntityGetAllChildren( player_entity )
	if ( player_child_entities ~= nil ) then
		for i, child_entity in ipairs( player_child_entities ) do
			local child_entity_name = EntityGetName( child_entity )
			
			if ( child_entity_name == "cape" ) then
				cape = child_entity
			end
			
			if ( child_entity_name == "arm_r" ) then
				player_arm = child_entity
			end
		end
	end
	
	-- set player sprites (since we need multiple components of the same type, a for loop is used.)
	local player_sprite_components = EntityGetComponent(player_entity, "SpriteComponent")
	for i, component in ipairs(player_sprite_components) do
		sprite = ComponentGetValue(component, "image_file")
		if sprite ~= nil then
			if string.find(sprite, "/player.xml") then
				ComponentSetValue(component, "image_file", "mods/prismatic_wardrobe/files/" .. loadout_choice.folder .. "/player.xml")
			elseif string.find(sprite, "/player_lukky.xml") then
				ComponentSetValue(component, "image_file", "mods/prismatic_wardrobe/files/" .. loadout_choice.folder .. "/player_lukky.xml")
			elseif string.find(sprite, "/player_amulet.xml") then
				ComponentSetValue(component, "image_file", "mods/prismatic_wardrobe/files/" .. loadout_choice.folder .. "/player_amulet.xml")
			elseif string.find(sprite, "/player_amulet_gem.xml") then
				ComponentSetValue(component, "image_file", "mods/prismatic_wardrobe/files/" .. loadout_choice.folder .. "/player_amulet_gem.xml")
			elseif string.find(sprite, "/player_hat.xml") then
				ComponentSetValue(component, "image_file", "mods/prismatic_wardrobe/files/" .. loadout_choice.folder .. "/player_hat.xml")
			elseif string.find(sprite, "/player_hat2.xml") then
				ComponentSetValue(component, "image_file", "mods/prismatic_wardrobe/files/" .. loadout_choice.folder .. "/player_hat2.xml")
			elseif string.find(sprite, "/player_hat2_shadow.xml") then
				ComponentSetValue(component, "image_file", "mods/prismatic_wardrobe/files/" .. loadout_choice.folder .. "/player_hat2_shadow.xml")
			end
		end
	end
	
	-- set player arm sprite
	local player_arm_sprite_component = EntityGetFirstComponent(player_arm, "SpriteComponent")
	local player_arm_sprite_file = "mods/prismatic_wardrobe/files/" .. loadout_choice.folder .. "/player_arm.xml"
	ComponentSetValue(player_arm_sprite_component, "image_file", player_arm_sprite_file)
	
	-- set player cape colour (since we're changing multiple variables, we'll use the edit_component() utility)
	edit_component( cape, "VerletPhysicsComponent", function(comp,vars) 
		vars.cloth_color = loadout_cape_color
		vars.cloth_color_edge = loadout_cape_color_edge
	end)
	
	-- set player ragdoll
	local player_ragdoll_component = EntityGetFirstComponent(player_entity, "DamageModelComponent")
	local player_ragdoll_file = "mods/prismatic_wardrobe/files/" .. loadout_choice.folder .. "/ragdoll/filenames.txt"
	ComponentSetValue(player_ragdoll_component, "ragdoll_filenames_file", player_ragdoll_file)
	
	GlobalsSetValue("lukki_leg_sprite_file", "mods/prismatic_wardrobe/files/" .. loadout_choice.folder .. "/mutation/lukki_leg.png")
	GlobalsSetValue("lukki_knee_sprite_file", "mods/prismatic_wardrobe/files/" .. loadout_choice.folder .. "/mutation/lukki_knee.png")
	GlobalsSetValue("lukki_foot_sprite_file", "mods/prismatic_wardrobe/files/" .. loadout_choice.folder .. "/mutation/lukki_foot.png")
end

ModLuaFileAppend("data/scripts/perks/perk_list.lua", "mods/prismatic_wardrobe/files/perk_edits.lua")

